<template>
  <div class="_container">
    <rui-loading v-if="loading === true" class="-mvd" :text="$t('generic.loading')" />
    <rui-errors v-else-if="loadingError" :errors="loadingError" />

    <gpa-activities v-else :activities="activities" />
  </div>
</template>

<script>
import RuiErrors from '@experiments-labs/rise_ui/src/components/DataDisplay/Error/Errors.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'

import Activity from '../../../classes/models/Activity'
import GpaActivities from './Activities/_Activities.vue'

export default {
  name: 'GpaInventoryActivity',
  components: { RuiErrors, RuiLoading, GpaActivities },
  data () {
    return {
      activities: [],
      loading: false,
      loadingError: null,
    }
  },
  created () {
    this.loading = true
    this.loadingError = null

    const subjectType = this.$route.name.match('inventory-element') ? 'Element' : 'Patch'
    const subjectId = this.$route.params[this.subjectType === 'Element' ? 'elementId' : 'patchId']

    Activity.getActivitiesForSubject(subjectType, subjectId)
      .then((activities) => { this.activities = activities })
      .catch((error) => { this.loadingError = error })
      .then(() => { this.loading = false })
  },
}
</script>
